/****************************************Copyright (c)****************************************************
**                            Guangzhou ZLGMCU Development Co., LTD
**
**                                 http://www.zlgmcu.com
**
**--------------File Info---------------------------------------------------------------------------------
** File name:           main.c
** Last modified Date:  2015-8-13
** Last Version:        V1.0
** Descriptions:         
**
**--------------------------------------------------------------------------------------------------------
** Created by:          yanghongyu
** Created date:        2015-6-06
** Version:             V1.00
** Descriptions:         
**
**--------------------------------------------------------------------------------------------------------
** Modified by:         heyuanfeng
** Modified date:       2017-5-2
** Version:             V1.03
** Descriptions:        LoRaʼظõBug
                        ɾFSKֻLORA
*********************************************************************************************************/
#include "LPC11xx.h"                                                    /* LPC11xxĴ            */
#include "uart.h" 

#include "stdint.h"
#include "stdio.h"

#include "platform.h"
#include "radio.h"
#include "sx1276-LoRa.h"
#include "sx1276-Hal.h"
#include "sx1276.h"


/*********************************************************************************************************
  궨
*********************************************************************************************************/
#define LED_INIT()    LPC_GPIO2->DIR  |=  0XFF0                         /* LEDʼ                    */


void SX1276LoRaSetSpreadingFactor( uint8_t factor );
tRadioDriver *Radio = 0;

extern uint16_t   uiByteNum;									        /*  ڽݸ            */

uint8_t   ucRxbuf[PACK_LENGTH]  = {0};                                  /*  ݻ              */
uint8_t   ucTxbuf[PACK_LENGTH] = {0};                                   /*  ݻ洮ڻ    */
uint16_t  uiMs          = 0; 

static uint8_t    ucsleep  = 0;
static uint8_t    led  = 0;
static uint8_t    UPwr = 20;                                             /*  书,С5dBm,20dBm */
char GcRcvBuf[100] = {0};
/*********************************************************************************************************
** Function name:        LED_Show
** Descriptions:         
** input parameters:     ucled 
** output parameters:    
*********************************************************************************************************/
void LED_Show(unsigned char ucled)
{

	unsigned int temp = 0;
		
	 /* ȵIO˳,ٸֵ */
	temp |= (ucled & (1ul << 7)) >> 5;   /* LED7,DIO6 */
	temp |= (ucled & (1ul << 6)) >> 3;   /* LED6,DIO7 */
	temp |= (ucled & (1ul << 5)) >> 1;   /* LED5,DIO8 */	
	temp |= (ucled & (1ul << 4)) >> 4;   /* LED4,DIO4 */
	temp |= (ucled & (1ul << 3)) >> 2;   /* LED3,DIO5 */	
	temp |= (ucled & (1ul << 2)) << 3;   /* LED2,DIO9 */
	temp |= (ucled & (1ul << 1)) << 5;   /* LED1,DIO10 */	
	temp |= (ucled & (1ul << 0)) << 7;   /* LED0,DIO11 */

	LPC_GPIO2->DATA &= 0x00f;
	LPC_GPIO2->DATA |= ~(temp << 4);
}
/*********************************************************************************************************
** Function name:        dellayms
** Descriptions:         
** input parameters:     uiNum: 
** output parameters:    
*********************************************************************************************************/
void delayms(unsigned int uiNum)
{
	unsigned int i = 0;
	unsigned int j = 0;
	while(i < uiNum) {
		i++;
		for(j = 0; j < 4369; j++);
	}
}
/*********************************************************************************************************
** Function name:       KEY2_INT
** Descriptions:        S2Ӧжϳʼ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void KEY2_INT (void)
{
	LPC_GPIO1->DIR &= ~ (1ul << 2);                                     /*  P1.2Ϊ              */
	LPC_GPIO1->IS   = 0x00;                                             /*  P1.2Ϊж              */
	LPC_GPIO1->IEV &= (1ul << 2);                                       /*  ½ж                  */
	LPC_GPIO1->IE  |= (1ul << 2);                                       /*  P1.2жϲ              */		
	NVIC_EnableIRQ(EINT1_IRQn);                                         /* жϲʹ               */
	NVIC_SetPriority(EINT1_IRQn, 2);	
}
/*********************************************************************************************************
** Function name:       PIOINT1_IRQHandler
** Descriptions:        S2ӦжϷһ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void PIOINT1_IRQHandler  (void)
{
	uint16_t  i      = 0;	
	
	delayms(10); 
	while(!(LPC_GPIO1->DATA & (1ul << 2)));															/*  ȴɿ                */

	for(i = 0; i < 50; i++) {
		ucTxbuf[i] = i;
	}
	uiByteNum = 10; 
	uiMs = 2;                                                           /* ʹܷ                 */

	LPC_GPIO1->IC |= (1ul << 2);                                        /*  жϱ־                */

}
/*********************************************************************************************************
** Function name:       KEY3_INT
** Descriptions:        жϳʼ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void KEY3_INT (void)
{
	LPC_GPIO0->DIR &= ~ (1ul << 7);                                     /*  P0.7Ϊ              */
	LPC_GPIO0->IS   = 0x00;                                             /*  P0.7Ϊж              */
	LPC_GPIO0->IEV &= ~(1ul << 7);                                      /*  ½ж                  */
	LPC_GPIO0->IE  |= (1ul << 7);                                       /*  P0.7жϲ              */		
	NVIC_EnableIRQ(EINT0_IRQn);                                         /* жϲʹ               */
	NVIC_SetPriority(EINT0_IRQn, 2);	
	LPC_GPIO0->IC |= (1ul << 7);                                        /*  жϱ־                */
}
/*********************************************************************************************************
** Function name:       PIOINT0_IRQHandler
** Descriptions:        S3жϷ
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void PIOINT0_IRQHandler  (void)
{
	UPwr++;
	if (UPwr > 20) {
		UPwr = 5;
	}	
	while(!(LPC_GPIO0->DATA & (1ul << 7)));								
	delayms(10); 
	LPC_GPIO0->IC |= (1ul << 7);                                       
	//LED_Show(UPwr);

	SX1276TxPower(UPwr);
	sprintf(GcRcvBuf,"\r\nPower:%d",UPwr);uartSendStr(GcRcvBuf); 
}
/*********************************************************************************************************
** Function name:       DisableIRQ
** Descriptions:        رж
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void DisableIRQ (void)
{
	NVIC_DisableIRQ(EINT0_IRQn);			      
	NVIC_DisableIRQ(EINT1_IRQn);
}
/*********************************************************************************************************
** Function name:       EnableIRQ
** Descriptions:        ָж
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
void EnableIRQ (void)
{
	NVIC_EnableIRQ(EINT0_IRQn);                                         
	NVIC_EnableIRQ(EINT1_IRQn);  	
}
/*********************************************************************************************************
** Function name:       main
** Descriptions:        Ӧú
** input parameters:    
** output parameters:   
** Returned value:      
*********************************************************************************************************/
int main(void)
{
	double crssi;
	uint8_t  UPwr;	
	uint8_t   j      = 0;
	uint16_t  i      = 0;		
	uint16_t  temp      = 0x5f;	
	uint8_t   tempbuf[PACK_LENGTH]  = {0};
	uint32_t  Freq;
	//ϵͳʼ11.0592MHz
	SystemInit();                                                       			
	LPC_SYSCON->SYSAHBCLKCTRL |= (1 << 6);  	
	//ʼLED
	LED_INIT();                                                         	
	//ʼUART
	uartInit();                                                         		 
	//ʼťS3ж;Ӧ
	KEY3_INT();			                                               
	//ʼťS2ж 
	KEY2_INT();														    
	//λSPI
	SX1276Reset();
	if(SX1276CheckSPI())
		LED_Show(0x18);//SPI
	else{
		LED_Show(0xff);//SPI
		while(1) ;//ѭ
	}
	//ʼģ
	SX1276Init();   
	//ʼɺƵ470Mhz
	Freq = 470000000;
	UPwr = 20;
	SX1276FreqSet(Freq);
	//÷书Ϊ20dBM
	SX1276TxPower(UPwr);
	//״̬
	SX1276SetOpMode(RFLR_OPMODE_STANDBY);
	//״̬
	SX1276RxStateEnter(); 
	sprintf(GcRcvBuf,"\r\nInitialization finished.\r\nFreq:%dhz Power:%2ddBm\n",Freq,UPwr);uartSendStr(GcRcvBuf); 
	while (1){
	// 
	//DIO0ߵƽյ
		if (1 == SX1276Dio0State()){                               	
			//RFоƬFIFOеݶ
			//SX1276RxDataRead( &ucRxbuf[0], &j );   ʹCRC32У
			SX1276RxDataReadCRC32( &ucRxbuf[0], &j );//ʹCRC32У
			//״̬
			SX1276RxStateEnter(); 				
			if(j > 0){
				crssi = GetPackLoRaRSSI();				
				for (temp = 0; temp < j; temp++) {
					//ݴӴͳȥ
					uartSendByte(ucRxbuf[temp]);                   			
				}
				//յݼ1
				led++;                                                 
				led = led % 128; 
				LED_Show(led);
			}			
		}
		//	
		//ߴڻճʱѻݷͳȥ
		if(uiByteNum >= PACK_LENGTH || uiMs == 1){
			//ʧж,ֹSPIʱ
			DisableIRQ();                                                
			//ʧUARTж
			NVIC_DisableIRQ(UART_IRQn);                         
			//Ѵڻݶ
			for(i = 0; i < uiByteNum; i++){
				tempbuf[i] = ucTxbuf[i];                                 
			}
			//ݱ־
			uiByteNum = 0;
			//ʹUARTж
			NVIC_EnableIRQ(UART_IRQn);                             		
			LED_Show(0x80);	
			//ݳȥ
			//SX1276TxData(&tempbuf[0], i);            ʹCRC32У
			if(SX1276TxDataCRC32(&tempbuf[0], i)!=0){  //ʹCRC32У
				//ʧ
				delayms(100);
				LED_Show(0xff);	
				delayms(100);
				LED_Show(0x80);	
			}
			//״̬
			SX1276RxStateEnter();                   
			//ָж
			EnableIRQ();                                 
			LED_Show(led);
			uiMs = 0;    
			//
			if(ucsleep == 1){
				//,1.2uA
				SX1276SetOpMode(RFLR_OPMODE_SLEEP);                    
				ucsleep = 0;
			}	
		}
		if(uiByteNum > 0){
			//С1msʱ
			delayms(1); 	                                           
			if(uiMs > 0){
				//ȴڽʱ1
				uiMs--;                                                  
			}   
		}	
	}
}

/*********************************************************************************************************
  End Of File
*********************************************************************************************************/
